﻿//2D vector class for brownian motion and jiggling
class Vector{
	var x:Number;
	var y:Number;
	var xReal:Number;
	var yReal:Number;
	var dist:Number;
	function Vector (x:Number, y:Number, dist:Number){
		this.x = x;
		this.y = y;
		this.xReal = x;
		this.yReal = y;
		this.dist = dist;
	}
	//brownian motion function
	public function drift():Void{
		switch(random(4)){
			case 0:
			x++;
			xReal++;
			break;
			case 1:
			y++;
			yReal++;
			break;
			case 2:
			x--;
			xReal--;
			break;
			case 3:
			y--;
			yReal--;
			break;
		}
	}
	//keep on screen function
	public function keepOnScreen(wide:Number, high:Number, offset:Number):Void{
		if(xReal - offset > wide) xReal = 0 - offset;
		if(yReal - offset > high) yReal = 0 - offset;
    	if(xReal + offset < 0) xReal = wide + offset;
    	if(yReal + offset < 0) yReal = high + offset;
	}
	//assignment function 
	public function assign(xAdd:Number, yAdd:Number):Void{
		x += xAdd;
		xReal += xAdd;
		y += yAdd;
		yReal += yAdd;
	}
	//jiggling function
	public function dither():Void{
		switch(random(4)){
			case 0:
			x++;
			break;
			case 1:
			y++;
			break;
			case 2:
			x--;
			break;
			case 3:
			y--;
			break;
		}
		if(distanceN(xReal, yReal) > dist){
			x = xReal;
			y = yReal;
		}
	}
	//drift towards another vector function
	public function driftTo(temp:Vector){
		if(xReal < temp.xReal){
			xReal++;
			x++;
		}
		if(yReal < temp.yReal){
			yReal++;
			y++;
		}
		if(xReal > temp.xReal){
			xReal--;
			x--;
		}
		if(yReal > temp.yReal){
			yReal--;
			y--;
		}
	}
	//evaluation function
	public function equals (temp:Vector):Boolean{
		if(temp.xReal == xReal && temp.yReal == yReal){
			return true;
		}
		return false;
	}
	//pythagorean distance function
	public function distance (temp:Vector):Number{
		return Math.sqrt(((temp.x - x) * (temp.x - x)) + ((temp.y - y) * (temp.y - y)));
	}
	//pythagorean distance function
	public function distanceN (tempx:Number, tempy:Number):Number{
		return Math.sqrt(((tempx - x) * (tempx - x)) + ((tempy - y) * (tempy - y)));
	}
}